<div #valueWrapper [attr.data-test-element-id]="'select-field-component'">
  @if (value) {
    <span
      (click)="enableEditMode()"
      class="field-value-color"
      [class.editable]="editable"
    >
      {{ getOptionLabel(value) }}
    </span>
  }
  @if (mustShowPlaceHolder(value, allowEmptyValue)) {
    <span
      class="sqtm-placeholder"
      (click)="enableEditMode()"
      [class.editable]="editable"
    >
      {{ getActualPlaceHolder() }}
    </span>
  }
  @if (editable) {
    <i
      class="caret-icon flex-fixed-size"
      nz-icon
      nzType="caret-down"
      nzTheme="outline"
      (click)="enableEditMode()"
    ></i>
  }
</div>
<div
  #selectFieldWrapper
  class="hide"
  [attr.data-test-element-id]="'select-field-wrapper'"
>
  <div class="flex-row full-width">
    <nz-select
      class="full-width overflow-hidden"
      #selectField
      [nzShowSearch]="searchable"
      [ngModel]="transientValue"
      [nzSize]="size"
      (ngModelChange)="change($event)"
      [nzPlaceHolder]="placeHolder"
      [nzAllowClear]="allowEmptyValue"
      (nzBlur)="handleClickOut()"
      (nzOpenChange)="
        disableEditModeIfSelectedValueIsTheSameInNoButtonMode($event)
      "
      [nzLoading]="layout === 'no-buttons' && pending"
    >
      @for (
        option of getVisibleOptions(allOptions, excludedKeys);
        track trackByOptionValue($index, option)
      ) {
        <nz-option
          nzValue="{{ option.value }}"
          nzLabel="{{ option.label }}"
          nzCustomContent
          [nzHide]="option.hide"
        >
          {{ option.label }}
        </nz-option>
      }
    </nz-select>
    @if (mustShowButtons()) {
      <div class="flex-fixed-size">
        <button
          nz-button
          nzType="primary"
          [attr.data-test-button-id]="'confirm'"
          [ngClass]="getConfirmButtonCss()"
          [nzSize]="size"
          [nzLoading]="pending"
          (click)="confirm()"
        >
          <i nz-icon [nzType]="'check'"></i>
          @if (mustShowButtonLabels()) {
            {{ 'sqtm-core.generic.label.confirm' | translate | capitalize }}
          }
        </button>
      </div>
    }
    @if (mustShowButtons()) {
      <div class="flex-fixed-size">
        <button
          nz-button
          nzType="default"
          [attr.data-test-button-id]="'cancel'"
          [nzSize]="size"
          [ngClass]="getCancelButtonCss()"
          [nzLoading]="pending"
          (click)="cancel()"
        >
          <i nz-icon [nzType]="'close'"></i>
          @if (mustShowButtonLabels()) {
            {{ 'sqtm-core.generic.label.cancel' | translate | capitalize }}
          }
        </button>
      </div>
    }
  </div>
</div>
